#!/bin/bash

wifi_conn=$(nmcli -t -f NAME,TYPE connection show --active | grep ":*wireless" | cut -d: -f1)

if [ -n "$wifi_conn" ]; then
    current_setting=$(nmcli -g 802-11-wireless.cloned-mac-address connection show "$wifi_conn")

    if [[ "$current_setting" != "random" ]]; then
        echo "[+] Setting up cloned-mac-address=random for '$wifi_conn'"
        nmcli connection modify "$wifi_conn" 802-11-wireless.cloned-mac-address random

        echo "[~] Restarting connection '$wifi_conn'..."
        nmcli connection down "$wifi_conn"
        sleep 2
        nmcli connection up "$wifi_conn"
    else
        echo "[✓] '$wifi_conn' already using random MAC"
    fi
else
    echo "[!] There is no active Wi-Fi connection — skip"
fi
